require 'date'

SSHKit.config.command_map[:php] = '/usr/bin/env php -dmemory_limit=-1'
SSHKit.config.command_map[:composer] = SSHKit.config.command_map[:php], '-f /usr/local/bin/composer'
SSHKit.config.command_map[:n98magerun] = SSHKit.config.command_map[:php], '-f /usr/local/bin/n98-magerun'
SSHKit.config.command_map[:magento] = SSHKit.config.command_map[:php], '-f bin/magento --'

load File.expand_path('../tasks/sozo_magento2.rake', __FILE__)
load File.expand_path('../tasks/deploy.rake', __FILE__)
load File.expand_path('../tasks/composer.rake', __FILE__)
load File.expand_path('../tasks/sozo.rake', __FILE__)
load File.expand_path('../tasks/slack.rake', __FILE__)
load File.expand_path('../tasks/db.rake', __FILE__)
load File.expand_path('../tasks/fishpig.rake', __FILE__)
load File.expand_path('../tasks/magento2.rake', __FILE__)
load File.expand_path('../tasks/provision.rake', __FILE__)
load File.expand_path('../tasks/server.rake', __FILE__)
load File.expand_path('../tasks/wordpress.rake', __FILE__)

after 'deploy:check', 'sozo:git:check'
after 'deploy:check', 'sozo:info'

after 'deploy:updating', 'composer:install'
after 'deploy:updating', 'magento:patches:apply'
after 'deploy:updating', 'magento:setup:permissions'

before 'deploy:updated', 'slack:deploying'
before 'deploy:updated', 'db:backup'
before 'deploy:updated', 'magento:cron:remove'
before 'deploy:updated', 'sozo:config:setup'
before 'deploy:updated', 'magento:maintenance:enable'

after 'deploy:updated', 'provision:setup_dir'
after 'deploy:updated', 'magento:setup:upgrade'
after 'deploy:updated', 'magento:setup:di:compile'
after 'deploy:updated', 'magento:setup:static-content:deploy'
after 'deploy:updated', 'provision:permissions'

after 'deploy:finishing', 'sozo:symlink'
after 'deploy:finishing', 'fishpig:setup:install_theme' 
after 'deploy:finishing', 'wordpress:sozo_mu'
after 'deploy:finishing', 'wordpress:cleanup'
after 'deploy:finishing', 'sozo:optimise'
after 'deploy:finishing', 'server:service:restart'
after 'deploy:finishing', 'magento:maintenance:disable'
after 'deploy:finishing', 'magento:cron:install'

after 'deploy:finished', "slack:deployed"
after 'deploy:finished', "db:cleanup"

after 'deploy:failed', "sozo:fix_current"
after 'deploy:failed', "slack:failed"
after 'deploy:failed', 'magento:cron:remove'
after 'deploy:failed', 'magento:cron:install'
after 'deploy:failed', 'magento:maintenance:disable'

namespace :load do
    task :defaults do
        load 'capistrano/sozo_magento2/defaults.rb'
    end
end