set :linked_files, fetch(:linked_files, []).push()

set :linked_dirs, fetch(:linked_dirs, []).push(
    'magento/pub/media',
    'magento/pub/sitemap',
    'magento/var/amasty/geoip',
    'magento/var/backups',
    'magento/var/composer_home',
    'magento/var/importexport',
    'magento/var/import_history',
    'magento/var/export',
    'magento/var/log',
    'magento/var/nginx',
    'magento/var/report',
    'magento/var/session', 
    'magento/var/tmp',
    'magento/wp/wp-content/uploads'
)

# Composer defaults
set :composer_flags,                '--no-dev --optimize-autoloader --prefer-dist --no-interaction --no-suggest'
set :composer_dev_flags,            '--prefer-dist --no-interaction --no-suggest'
set :composer_require_flags,        '--update-no-dev --optimize-autoloader --prefer-dist --no-suggest'
set :composer_require_dev_flags,    '--optimize-autoloader --prefer-dist'

# DB defaults
set :date_path,                     Time.now.strftime("%Y%m%d%H%M%S")
set :backupdir,                     ->{ "#{fetch(:deploy_root)}/backups" }
set :backupdirdate,                 ->{ "#{fetch(:backupdir)}/#{fetch(:date_path)}" }
set :keep_backups,                  fetch(:keep_backups, 10)

# WordPress integration defaults
set :wp_backup,                     fetch(:wp_backup, true)
set :wp_delete_themes,              fetch(:wp_delete_themes, 'twentyseventeen twentynineteen twentytwenty')
set :wp_delete_plugins,             fetch(:wp_delete_plugins, 'hello')
set :wp_disable_plugins,            fetch(:wp_disable_plugins, '')

# Slack defaults
set :slack_channel,                 fetch(:slack_channel, '#deployments')
set :slack_webhook,                 'https://hooks.slack.com/services/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'

# Deployment defaults
set :magento_deploy_confirm_roles,  fetch(:magento_deploy_confirm_roles, [])

# Handle removing and installing of cron tasks?
set :handle_cron,                   fetch(:handle_cron, false)

# Other defaults (for future use)
# Clear or leave the failed deployment dirs
set :clear_failures,                fetch(:clear_failures, true)