# Composer namespace
namespace :composer do
    desc "Install the Composer dependencies"
    task :install do
        on roles(:all, filter: :composer_dev) do
            within release_path + 'magento/' do
                execute :composer, "install", fetch(:composer_dev_flags)
            end
        end

        on roles(:all, exclude: :composer_dev) do
            within release_path + 'magento/' do
                execute :composer, "install", fetch(:composer_flags)
            end
        end
    end

    desc "Update the Composer dependencies"
    task :update do
        on roles(:all, filter: :composer_dev) do
            within release_path + 'magento/' do
                execute :composer, "update", fetch(:composer_dev_flags)
            end
        end

        on roles(:all, exclude: :composer_dev) do
            within release_path + 'magento/' do
                execute :composer, "update", fetch(:composer_flags)
            end
        end
    end

end
